## rainbow 0.8.6

=== Makefile ===
export DESTDIR ?= /
export PREFIX ?= /usr
export BINDIR ?= $(DESTDIR)$(PREFIX)/bin
export SBINDIR ?= $(DESTDIR)$(PREFIX)/sbin
export LOCALSTATEDIR ?= $(DESTDIR)/var
export SYSCONFDIR ?= $(DESTDIR)/etc
export LIBDIR ?= $(DESTDIR)$(PREFIX)/lib

# targets
build:
	python setup.py build
	$(MAKE) -C nss

install:
	python setup.py install --root=$(DESTDIR)
	$(MAKE) -C bin install
	$(MAKE) -C nss install
	install -d $(SYSCONFDIR)/security/console.perms.d/
	install -m 0644 rainbow/conf/51-rainbow.perms $(SYSCONFDIR)/security/console.perms.d/51-rainbow.perms
	install -d $(LOCALSTATEDIR)/spool/rainbow/2

.PHONY: build install

# vim: noet sts=4 ts=4 sw=4 :

=== bin/Makefile ===

install:
	install -D -m 0755 rainbow-run        $(BINDIR)/rainbow-run
	install -D -m 0755 rainbow-easy       $(BINDIR)/rainbow-easy
	install -D -m 0755 rainbow-resume     $(BINDIR)/rainbow-resume
	install -D -m 0755 rainbow-gc         $(BINDIR)/rainbow-gc
	install -D -m 0755 rainbow-sugarize   $(BINDIR)/rainbow-sugarize
	install -D -m 0755 rainbow-xify       $(BINDIR)/rainbow-xify
	install -D -m 0755 mkenvdir           $(BINDIR)/mkenvdir

.PHONY: install

=== nss/Makefile ===

WARNFLAGS = \
        -W -Wformat -Wall -Wundef -Wpointer-arith -Wcast-qual \
        -Wcast-align -Wwrite-strings -Wsign-compare \
        -Wmissing-noreturn \
        -Wextra -Wstrict-aliasing=2 \
        -Wunsafe-loop-optimizations \
		-Wuninitialized

# Compiler flags for generating dependencies
DEPFLAGS = -MMD -MP
CFLAGS ?= -O3
# CFLAGS ?= -O0 -g
# LDFLAGS ?= -g
ALLCFLAGS = -std=gnu99 -fPIC $(WARNFLAGS) $(DEPFLAGS) $(CFLAGS)

# declarations

RAINBOW_OBJS = nss-rainbow.o buf.o nat.o slist.o
UIDS_OBJS = uids.o
GIDS_OBJS = gids.o
TEST_SLIST_OBJS = test_slist.o slist.o
TEST_ENDGRENT_OBJS = test_endgrent.o
TEST_NAT_OBJS = test_nat.o nat.o
ALL_OBJS = $(RAINBOW_OBJS) $(UIDS_OBJS) $(GIDS_OBJS) $(TEST_SLIST_OBJS) $(TEST_NAT_OBJS)
BINARIES = libnss_rainbow.so.2 uids gids test_slist test_nat test_endgrent

# targets

all: $(BINARIES)

clean:
	rm -f $(BINARIES) *.d *.o

install:
	install -D -m 0755 libnss_rainbow.so.2 $(LIBDIR)/libnss_rainbow.so.2

# objects

%.o: %.c
	$(CC) $(ALLCFLAGS) -c -o $@ $<


# linked binaries

test_endgrent: $(TEST_ENDGRENT_OBJS)
	$(CC) $(ALLCFLAGS) -o $@ $^

test_slist: $(TEST_SLIST_OBJS)
	$(CC) $(ALLCFLAGS) -o $@ $^

test_nat: $(TEST_NAT_OBJS)
	$(CC) $(ALLCFLAGS) -o $@ $^

uids: $(UIDS_OBJS)
	$(CC) $(ALLCFLAGS) -o $@ $^

gids: $(GIDS_OBJS)
	$(CC) $(ALLCFLAGS) -o $@ $^

libnss_rainbow.so.2: $(RAINBOW_OBJS)
	$(CC) -shared $(LDFLAGS) -o $@ -Wl,-soname,$@ $^


.PHONY: clean install

-include $(ALL_OBJS:%.o=%.d)

# vim: noet sts=4 ts=4 sw=4 :

## rainbow 0.8.7

=== Makefile ===
--- 
+++ 
@@ -19,6 +19,9 @@
 	install -m 0644 rainbow/conf/51-rainbow.perms $(SYSCONFDIR)/security/console.perms.d/51-rainbow.perms
 	install -d $(LOCALSTATEDIR)/spool/rainbow/2
 
-.PHONY: build install
+clean:
+	$(MAKE) -C nss clean
+
+.PHONY: build install clean
 
 # vim: noet sts=4 ts=4 sw=4 :

=== bin/Makefile ===

install:
	install -D -m 0755 rainbow-run        $(SBINDIR)/rainbow-run
	install -D -m 0755 rainbow-easy       $(SBINDIR)/rainbow-easy
	install -D -m 0755 rainbow-resume     $(SBINDIR)/rainbow-resume
	install -D -m 0755 rainbow-gc         $(SBINDIR)/rainbow-gc
	install -D -m 0755 rainbow-sugarize   $(BINDIR)/rainbow-sugarize
	install -D -m 0755 rainbow-xify       $(BINDIR)/rainbow-xify
	install -D -m 0755 mkenvdir           $(BINDIR)/mkenvdir

.PHONY: install

=== nss/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 
 WARNFLAGS = \
-        -W -Wformat -Wall -Wundef -Wpointer-arith -Wcast-qual \
+        -Wformat -Wall -Wundef -Wpointer-arith -Wcast-qual \
         -Wcast-align -Wwrite-strings -Wsign-compare \
         -Wmissing-noreturn \
         -Wextra -Wstrict-aliasing=2 \
@@ -22,8 +22,17 @@
 TEST_SLIST_OBJS = test_slist.o slist.o
 TEST_ENDGRENT_OBJS = test_endgrent.o
 TEST_NAT_OBJS = test_nat.o nat.o
+TEST_FORMAT_BUF_OBJS = test_format_buf.o buf.o
 ALL_OBJS = $(RAINBOW_OBJS) $(UIDS_OBJS) $(GIDS_OBJS) $(TEST_SLIST_OBJS) $(TEST_NAT_OBJS)
-BINARIES = libnss_rainbow.so.2 uids gids test_slist test_nat test_endgrent
+BINARIES = libnss_rainbow.so.2 uids gids test_slist test_nat test_endgrent test_format_buf
+
+# if you invoke make as 'make V=1' it will verbosely report on what it
+# is doing, otherwise it defaults to quiet/pretty mode, which makes
+# errors _much_ easier to see
+ifneq ($V, 1)
+MAKEFLAGS = -s
+endif
+
 
 # targets
 
@@ -38,27 +47,38 @@
 # objects
 
 %.o: %.c
+	@echo "  CC    $@"
 	$(CC) $(ALLCFLAGS) -c -o $@ $<
 
 
 # linked binaries
 
 test_endgrent: $(TEST_ENDGRENT_OBJS)
+	@echo "  LD    $@"
 	$(CC) $(ALLCFLAGS) -o $@ $^
 
 test_slist: $(TEST_SLIST_OBJS)
+	@echo "  LD    $@"
 	$(CC) $(ALLCFLAGS) -o $@ $^
 
 test_nat: $(TEST_NAT_OBJS)
+	@echo "  LD    $@"
+	$(CC) $(ALLCFLAGS) -o $@ $^
+
+test_format_buf: $(TEST_FORMAT_BUF_OBJS)
+	@echo "  LD    $@"
 	$(CC) $(ALLCFLAGS) -o $@ $^
 
 uids: $(UIDS_OBJS)
+	@echo "  LD    $@"
 	$(CC) $(ALLCFLAGS) -o $@ $^
 
 gids: $(GIDS_OBJS)
+	@echo "  LD    $@"
 	$(CC) $(ALLCFLAGS) -o $@ $^
 
 libnss_rainbow.so.2: $(RAINBOW_OBJS)
+	@echo "  LD    $@"
 	$(CC) -shared $(LDFLAGS) -o $@ -Wl,-soname,$@ $^

=== debian/changelog ===
rainbow (0.8.7-2) unstable; urgency=medium

  * Switch to dh_python2 (closes: #786050) 
  * Bump standards version; no changes required
  * Correct style/typo in rainbow short description
  * rules: Remove deprecated DEB_PYTHON_BUILD_ARGS

 -- Luke Faraone <lfaraone@debian.org>  Sat, 11 Jul 2015 21:35:53 +0000

rainbow (0.8.7-1) unstable; urgency=low

  * New upstream version
  * Add dependency on pandoc-data to fix FTBFS (closes: #724106)
  * Update Vcs-* field in debian/control
  * Update maintainer for my debian.org address.
  * Fix typo in man page.
  * Bump standards version; no changes required
  * Switch to dpkg-source 3.0 (quilt) format

 -- Luke Faraone <lfaraone@debian.org>  Sun, 22 Sep 2013 16:21:27 -0400

rainbow (0.8.6-1) unstable; urgency=low

  * New upstream version

 -- Luke Faraone <luke@faraone.cc>  Wed, 23 Dec 2009 15:10:58 -0500

rainbow (0.8.5-1) UNRELEASED; urgency=low

  * Initial release (Closes: #543688)

 -- Luke Faraone <luke@faraone.cc>  Wed, 26 Aug 2009 06:43:54 -0400

=== debian/control ===
Source: rainbow
Section: shells
Priority: optional
Maintainer: Luke Faraone <lfaraone@debian.org>
Build-Depends: python, python-setuptools, dh-python, cdbs (>= 0.4.90~), debhelper (>= 7), help2man, pandoc, pandoc-data
Standards-Version: 3.9.6
Vcs-Bzr: https://code.launchpad.net/~lfaraone/rainbow/debian
Homepage: http://wiki.laptop.org/go/Rainbow

Package: rainbow
Architecture: all
Depends: ${shlibs:Depends}, ${python:Depends}, ${misc:Depends}, libnss-rainbow2, python-rainbow
Provides: ${python:Provides}
Description: Bitfrost isolation shell
 Rainbow is a isolation shell which implements portions of the Bitfrost
 security architecture, as used on the OLPC XO-1 and elsewhere.
 .
 At the moment, Rainbow only knows how to provide the same primitive form
 of filesystem and signal isolation that competent sysadmins provide to
 users of multi-user Unix shell servers.

Package: libnss-rainbow2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: nss library for rainbow
 Rainbow is a isolation shell which implements portions of the Bitfrost
 security architecture, as used on the OLPC XO-1 and elsewhere.
 .
 This package contains an "Name Service Switch" plugin for glibc which
 permits Rainbow to easily create and remove users and groups without
 modifying /etc/passwd and /etc/group.

Package: python-rainbow
Section: python
Architecture: all
Depends: ${python:Depends}, ${misc:Depends}
Description: core rainbow shared module
 Rainbow is a isolation shell which implements portions of the Bitfrost
 security architecture, as used on the OLPC XO-1 and elsewhere.
 .
 This package contains the shared Python module used by the rainbow frontend.

=== debian/rules ===
#!/usr/bin/make -f

# python overrides:
DEB_PYTHON2_MODULE_PACKAGES = python-rainbow rainbow

#DEB_SRCDIR = $(CURDIR)/rainbow
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk
include /usr/share/cdbs/1/class/python-distutils.mk

# more overrides:
DEB_MAKE_INSTALL_TARGET = DESTDIR=$(CURDIR)/debian/tmp install
DH_VERBOSE=1

# custom stuff::
HELP2MAN_PROPS = --section=8 --no-info -S 'Rainbow User Manual' --include='./debian/help2man.include' 

# generate manpages. 
# PYTHONPATH specified so that the scripts execute properly without installation

build/rainbow::
	PYTHONPATH=. help2man $(HELP2MAN_PROPS) --name='Enable the use of the X display in rainbow-secured shells' ./bin/rainbow-xify > ./rainbow-xify.8
	PYTHONPATH=. help2man $(HELP2MAN_PROPS) --name='Create and use Rainbow-isolated instances' ./bin/rainbow-run > ./rainbow-run.8
	PYTHONPATH=. help2man $(HELP2MAN_PROPS) --name='Helper script for using Sugar with Rainbow' ./bin/rainbow-sugarize > ./rainbow-sugarize.8
	PYTHONPATH=. help2man $(HELP2MAN_PROPS) --name='Helper script which attempts to garbage-collect stale uid reservations' ./bin/rainbow-gc > ./rainbow-gc.8
	pandoc -s -w man ./debian/rainbow-easy.8.md -o rainbow-easy.8
	pandoc -s -w man ./debian/rainbow-resume.8.md -o rainbow-resume.8
	pandoc -s -w man ./debian/mkenvdir.1.md -o mkenvdir.1

clean::
	make -C nss clean
	rm -f rainbow-xify.8 rainbow-run.8 rainbow-sugarize.8 rainbow-easy.8 mkenvdir.1
	rm -rf rainbow.egg-info
	rm -rf build

=== debian/watch ===
version=3
http://dev.laptop.org/~mstone/releases/SOURCES/rainbow-(.*).tar.bz2

## rainbow 1.0

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, functional bagplot, functional HDR boxplot
Version: 1.0
Date: 2009-05-12
Depends: R (>= 2.6.0), hdrcde, ks, MASS, pcaPP
Suggests: tseries
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@buseco.monash.edu.au>
Description: Functions and datasets used in the JCGS paper
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2009-05-28 23:20:59 UTC; han
Repository: CRAN
Date/Publication: 2009-05-29 07:01:26

## rainbow 1.1

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, functional bagplot, functional HDR boxplot
Version: 1.1
Date: 2009-06-04
Depends: R (>= 2.6.0), hdrcde, ks, MASS, pcaPP
Suggests: tseries
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@buseco.monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2009-06-04 11:34:29 UTC; han
Repository: CRAN
Date/Publication: 2009-06-04 16:12:18

## rainbow 1.2

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, functional bagplot, functional HDR boxplot
Version: 1.2
Date: 2009-07-28
Depends: R (>= 2.6.0), hdrcde, ks, MASS, pcaPP, cluster
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@buseco.monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2009-07-28 03:26:05 UTC; han
Repository: CRAN
Date/Publication: 2009-07-28 13:20:03

## rainbow 1.3

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 1.3
Date: 2009-08-06
Depends: R (>= 2.6.0), hdrcde, ks, MASS, pcaPP, cluster
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@buseco.monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2009-08-06 06:53:15 UTC; Han
Repository: CRAN
Date/Publication: 2009-08-06 10:56:04

## rainbow 1.4

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 1.4
Date: 2009-09-04
Depends: R (>= 2.6.0), hdrcde, ks, MASS, pcaPP, cluster
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@buseco.monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2009-09-04 03:42:00 UTC; han
Repository: CRAN
Date/Publication: 2009-09-04 07:57:39

## rainbow 1.5

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 1.5
Date: 2009-10-08
Depends: R (>= 2.6.0), hdrcde, ks, MASS, pcaPP, cluster
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@buseco.monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2009-10-07 23:31:20 UTC; Han
Repository: CRAN
Date/Publication: 2009-10-08 12:41:51

## rainbow 1.6

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 1.6
Date: 2009-11-09
Depends: R (>= 2.6.0), hdrcde, ks, MASS, pcaPP, cluster
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@buseco.monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
URL: http://monashforecasting.com/index.php?title=R_packages
Repository: CRAN
Date/Publication: 2009-11-09 15:40:13
Packaged: 2009-11-09 07:25:58 UTC; han

## rainbow 1.7

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 1.7
Date: 2009-12-19
Depends: R (>= 2.6.0), hdrcde, MASS, pcaPP, cluster
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@buseco.monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2009-12-19 05:31:03 UTC; han
Repository: CRAN
Date/Publication: 2009-12-20 09:35:11

## rainbow 1.8

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 1.8
Date: 2010-01-27
Depends: R (>= 2.6.0), hdrcde, MASS, pcaPP, cluster
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@buseco.monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2010-01-26 22:32:58 UTC; hanshang
Repository: CRAN
Date/Publication: 2010-01-27 10:51:34

## rainbow 1.9

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 1.9
Date: 2010-03-15
Depends: R (>= 2.6.0), hdrcde, MASS, pcaPP, cluster
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@buseco.monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2010-03-15 01:35:31 UTC; hanshang
Repository: CRAN
Date/Publication: 2010-03-15 09:03:41

## rainbow 1.10

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 1.10
Date: 2010-03-26
Depends: R (>= 2.6.0), hdrcde, MASS, pcaPP, cluster
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@buseco.monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2010-03-26 03:52:31 UTC; hanshang
Repository: CRAN
Date/Publication: 2010-03-26 11:17:18

## rainbow 2.0

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 2.0
Date: 2010-05-12
Depends: R (>= 2.6.0), hdrcde, MASS, pcaPP, cluster
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@buseco.monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2010-05-12 06:47:49 UTC; hanshang
Repository: CRAN
Date/Publication: 2010-05-16 16:20:52

## rainbow 2.1

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 2.1
Date: 2010-08-05
Depends: R (>= 2.6.0), hdrcde, MASS, pcaPP, cluster
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@buseco.monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2010-08-05 05:12:25 UTC; hanshang
Repository: CRAN
Date/Publication: 2010-08-05 06:55:05

## rainbow 2.2

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 2.2
Date: 2010-09-10
Depends: R (>= 2.6.0), hdrcde, MASS, pcaPP, cluster
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@buseco.monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2010-09-10 03:25:11 UTC; Administrator
Repository: CRAN
Date/Publication: 2010-09-10 07:28:03

## rainbow 2.3.1

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 2.3.1
Date: 2010-09-22
Depends: R (>= 2.6.0), hdrcde, MASS, pcaPP, cluster
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@buseco.monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2010-09-22 07:56:41 UTC; Administrator
Repository: CRAN
Date/Publication: 2010-09-22 14:59:59

## rainbow 2.3.2

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 2.3.2
Date: 2011-02-06
Depends: R (>= 2.10.0), hdrcde, MASS, pcaPP, cluster
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
LazyDataCompression: xz
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2011-02-06 23:34:08 UTC; hanshang
Repository: CRAN
Date/Publication: 2011-02-07 09:50:39

## rainbow 2.3.3

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 2.3.3
Date: 2011-03-23
Depends: R (>= 2.10.0), hdrcde, MASS, pcaPP, cluster
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
LazyDataCompression: xz
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2011-03-23 06:26:25 UTC; hanshang
Repository: CRAN
Date/Publication: 2011-03-23 09:30:48

## rainbow 2.3.4

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 2.3.4
Date: 2011-03-24
Depends: R (>= 2.10.0), hdrcde, MASS, pcaPP, cluster
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
LazyDataCompression: xz
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2011-03-24 03:22:08 UTC; hanshang
Repository: CRAN
Date/Publication: 2011-03-24 08:01:49

## rainbow 2.3.5

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 2.3.5
Date: 2011-08-16
Depends: R (>= 2.10.0), hdrcde, MASS, pcaPP, cluster
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
LazyDataCompression: xz
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2011-08-16 10:27:40 UTC; hanshang
Repository: CRAN
Date/Publication: 2011-08-17 04:57:27

## rainbow 2.4

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 2.4
Date: 2011-09-12
Depends: R (>= 2.10.0), hdrcde, MASS, pcaPP, cluster, colorspace
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
LazyDataCompression: xz
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2011-09-13 01:57:10 UTC; hanshang
Repository: CRAN
Date/Publication: 2011-09-13 04:39:07

## rainbow 2.5

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 2.5
Date: 2011-09-13
Depends: R (>= 2.10.0), hdrcde, MASS, pcaPP, cluster, colorspace
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
LazyDataCompression: xz
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2011-09-13 10:13:49 UTC; hanshang
Repository: CRAN
Date/Publication: 2011-09-14 06:21:29

## rainbow 2.6

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 2.6
Date: 2011-09-16
Depends: R (>= 2.10.0), hdrcde, MASS, pcaPP, cluster, colorspace
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
LazyDataCompression: xz
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2011-09-16 11:19:00 UTC; hanshang
Repository: CRAN
Date/Publication: 2011-09-16 17:43:31

## rainbow 2.7

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 2.7
Date: 2011-10-16
Depends: R (>= 2.10.0), hdrcde, MASS, pcaPP, cluster, colorspace
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
LazyDataCompression: xz
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2011-10-16 22:29:35 UTC; hanshang
Repository: CRAN
Date/Publication: 2011-10-17 05:55:45

## rainbow 2.8

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 2.8
Date: 2012-01-10
Depends: R (>= 2.10.0), hdrcde, MASS, pcaPP, cluster, colorspace
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
LazyDataCompression: xz
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2012-01-10 01:18:47 UTC; hanshang
Repository: CRAN
Date/Publication: 2012-01-10 08:30:48

## rainbow 2.9

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 2.9
Date: 2012-06-04
Depends: R (>= 2.10.0), hdrcde, MASS, pcaPP, cluster, colorspace
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <HanLin.Shang@monash.edu.au>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
LazyDataCompression: xz
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2012-06-04 03:13:08 UTC; hanshang
Repository: CRAN
Date/Publication: 2012-06-04 05:33:41

## rainbow 3.0

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 3.0
Date: 2012-07-25
Depends: R (>= 2.10.0), hdrcde, MASS, pcaPP, cluster, colorspace
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <hanlin.shang@monash.edu>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
LazyDataCompression: xz
URL: http://monashforecasting.com/index.php?title=R_packages
Packaged: 2012-07-26 06:24:05 UTC; hanlinshang
Repository: CRAN
Date/Publication: 2012-07-26 06:31:10

## rainbow 3.1

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 3.1
Date: 2012-10-23
Depends: R (>= 2.10.0), hdrcde, MASS, pcaPP, cluster, colorspace
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <hanlin.shang@monash.edu>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
LazyDataCompression: xz
Packaged: 2012-10-23 11:58:48 UTC; hanlinshang
Repository: CRAN
Date/Publication: 2012-10-23 12:40:40

## rainbow 3.2

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow plots, bagplots and boxplots for functional data
Version: 3.2
Date: 2013-08-28
Depends: R (>= 2.10.0), MASS, pcaPP
Imports: hdrcde, cluster, colorspace, ks
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <H.Shang@soton.ac.uk>
Description: Functions and datasets for functional data display and
        outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
LazyDataCompression: xz
URL: https://sites.google.com/site/hanlinshangswebsite/
Packaged: 2013-08-28 14:58:45 UTC; hanlinshang
NeedsCompilation: no
Repository: CRAN
Date/Publication: 2013-08-28 17:48:39

## rainbow 3.3

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow Plots, Bagplots and Boxplots for Functional Data
Version: 3.3
Date: 2015-04-15
Depends: R (>= 2.10.0), MASS, pcaPP
Suggests: forecast
Imports: hdrcde, cluster, colorspace, ks
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <hanlin.shang@anu.edu.au>
Description: Functions and data sets for functional data display and outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
LazyDataCompression: xz
URL: https://sites.google.com/site/hanlinshangswebsite/
Packaged: 2015-04-15 12:14:46 UTC; hanlinshang
NeedsCompilation: no
Repository: CRAN
Date/Publication: 2015-04-15 21:41:07

## rainbow 3.4

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Rainbow Plots, Bagplots and Boxplots for Functional Data
Version: 3.4
Date: 2016-01-02
Depends: R (>= 3.2.3), MASS, pcaPP
Suggests: forecast
Imports: hdrcde, cluster, colorspace, ks
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <hanlin.shang@anu.edu.au>
Description: Functions and data sets for functional data display and outlier detection.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
LazyDataCompression: xz
URL: https://sites.google.com/site/hanlinshangswebsite/
NeedsCompilation: no
Packaged: 2016-01-03 01:55:28 UTC; hanlinshang
Repository: CRAN
Date/Publication: 2016-01-03 16:14:10

## rainbow 3.5

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Bagplots, Boxplots and Rainbow Plots for Functional Data
Version: 3.5
Date: 2018-10-18
Depends: R (>= 3.4.0), MASS, pcaPP
Suggests: forecast
Imports: hdrcde, cluster, colorspace, ks
Author: Han Lin Shang and Rob J Hyndman
Maintainer: Han Lin Shang <hanlin.shang@anu.edu.au>
Description: Visualizing functional data and identifying functional outliers.
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
LazyDataCompression: xz
URL: https://sites.google.com/site/hanlinshangswebsite/
NeedsCompilation: no
Packaged: 2018-10-18 03:31:57 UTC; hanlinshang
Repository: CRAN
Date/Publication: 2018-10-18 04:50:03 UTC

## rainbow 3.6

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Bagplots, Boxplots and Rainbow Plots for Functional Data
Version: 3.6
Date: 2019-1-29
Depends: R (>= 3.4.0), MASS, pcaPP
Suggests: forecast
Imports: hdrcde, cluster, colorspace, ks
LazyLoad: yes
LazyData: yes
ByteCompile: TRUE
Authors@R: c(
	person("Han Lin", "Shang", email="hanlin.shang@anu.edu.au", role=c("aut", "cre", "cph"), comment = c(ORCID = "0000-0003-1769-6430")),
	person("Rob", "Hyndman", role="aut", comment = c(ORCID = "0000-0002-2140-5352"))
	)    
Maintainer: Han Lin Shang <hanlin.shang@anu.edu.au>
Description: Visualizing functional data and identifying functional outliers.
License: GPL-3
NeedsCompilation: no
Packaged: 2019-01-29 07:24:55 UTC; hanlinshang
Author: Han Lin Shang [aut, cre, cph] (<https://orcid.org/0000-0003-1769-6430>),
  Rob Hyndman [aut] (<https://orcid.org/0000-0002-2140-5352>)
Repository: CRAN
Date/Publication: 2019-01-29 16:50:03 UTC

## rainbow 3.7

=== DESCRIPTION ===
Package: rainbow
Type: Package
Title: Bagplots, Boxplots and Rainbow Plots for Functional Data
Version: 3.7
Date: 2022-10-08
Depends: R (>= 4.0.0), MASS, pcaPP
Suggests: forecast
Imports: hdrcde, cluster, colorspace, ks, methods
LazyLoad: yes
LazyData: yes
ByteCompile: TRUE
Authors@R: c(
	person("Han Lin", "Shang", email="hanlin.shang@mq.edu.au", role=c("aut", "cre", "cph"), comment = c(ORCID = "0000-0003-1769-6430")),
	person("Rob", "Hyndman", role="aut", comment = c(ORCID = "0000-0002-2140-5352"))
	)
Maintainer: Han Lin Shang <hanlin.shang@mq.edu.au>
Description: Visualizing functional data and identifying functional outliers.
License: GPL-3
NeedsCompilation: no
Packaged: 2022-10-08 20:55:51 UTC; hanlinshang
Author: Han Lin Shang [aut, cre, cph] (<https://orcid.org/0000-0003-1769-6430>),
  Rob Hyndman [aut] (<https://orcid.org/0000-0002-2140-5352>)
Repository: CRAN
Date/Publication: 2022-10-09 22:20:02 UTC

## rainbow 3.8

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: rainbow
 Type: Package
 Title: Bagplots, Boxplots and Rainbow Plots for Functional Data
-Version: 3.7
-Date: 2022-10-08
+Version: 3.8
+Date: 2024-01-23
 Depends: R (>= 4.0.0), MASS, pcaPP
 Suggests: forecast
 Imports: hdrcde, cluster, colorspace, ks, methods
@@ -17,8 +17,8 @@
 Description: Visualizing functional data and identifying functional outliers.
 License: GPL-3
 NeedsCompilation: no
-Packaged: 2022-10-08 20:55:51 UTC; hanlinshang
+Packaged: 2024-01-22 22:57:28 UTC; hanlinshang
 Author: Han Lin Shang [aut, cre, cph] (<https://orcid.org/0000-0003-1769-6430>),
   Rob Hyndman [aut] (<https://orcid.org/0000-0002-2140-5352>)
 Repository: CRAN
-Date/Publication: 2022-10-09 22:20:02 UTC
+Date/Publication: 2024-01-23 05:40:07 UTC
